
  PROGRAM

  MAP
AnyTabProc PROCEDURE   
  END
INCLUDE('KeyCodes.clw')
INCLUDE('AnyScreen.inc')

  CODE
  AnyTabProc 

AnyTabProc PROCEDURE
LQ         QUEUE         !$ List 
Id           LONG
Str          STRING(30)
Mark         BYTE                           !Entry's marked status
ViewPosition STRING(1024)                   !Entry's view position
           END           
CQ         QUEUE         !$ Combo
Str          STRING(30)
Id           LONG
           END 
           
ICON:Ok     EQUATE('~Ok.ico')       
ICON:Cancel EQUATE('~Cancel.ico')  

lCheck      BYTE(False)  
lAmount     DECIMAL(9.2)
         
TabWindow WINDOW('Tab Window Caption'),AT(,,252,150),CENTER,GRAY,FONT('Tahoma',10)
          BOX,AT(1,1,250,108),USE(?BOX),COLOR(COLOR:Black),LINEWIDTH(1)
          SHEET,AT(2,110,250,12),USE(?SHEET),SPREAD,NOSHEET,BELOW,IMM
               TAB('Entry'),USE(?TAB:Entry)
                    PROMPT('&String Entry:'),AT(10,10),USE(?PROMPT:EntryStr)
                    ENTRY(@s30),AT(60,10,120,10),USE(?ENTRY:String),IMM,FLAT
                    PROMPT('&Amount Entry:'),AT(10,24),USE(?PROMPT:EntryAmt)
                    ENTRY(@n$13.2),AT(60,24,120,10),USE(lAmount,,?ENTRY:Amount),IMM,FLAT
               END
               TAB('Check'),USE(?TAB:Check)
                    CHECK('Check&box Control'),AT(10,10),USE(lCheck,, ?CHECK)
               END
               TAB('Option'),USE(?TAB:Option)
                    OPTION('Option&s'),AT(10,10,100,52),USE(?OPTION),BOXED
                         RADIO('Selection O&ne'),AT(20,22),USE(?RADIO:1)
                         RADIO('Selection &Two'),AT(20,34),USE(?RADIO:2)
                         RADIO('Selection T&hree'),AT(20,46),USE(?RADIO:3)
                    END
               END
               TAB('Combo'),USE(?TAB:Combo)
                    PROMPT('Co&mbo:'),AT(10,10),USE(?PROMPT:Combo)
                    COMBO(@s20),AT(50,10,120,10),USE(?COMBO),IMM,FLAT,NOBAR,VSCROLL, |
                              DROP(5,182),FROM(CQ),FORMAT('100L(2)|M15C|M@n1@')
               END
               TAB('Spin'),USE(?TAB:Spin)
                    PROMPT('&Date:'),AT(10,10),USE(?PROMPT:Date)
                    SPIN(@d01B),AT(40,10,70,10),USE(?SPIN:Date),IMM,FLAT,HSCROLL,REQ
               END
               TAB('List Box'),USE(?TAB:List)
                    LIST,AT(10,10,100,73),USE(?LIST),FLAT,NOBAR,VSCROLL,FROM(LQ), |
                              FORMAT('19C|F~ID~@n2@100L(1)|FM~String~C(0)@s20@')
               END
               TAB('Text Box'),USE(?TAB:Text)
                    PROMPT('Text Box'),AT(10,10),USE(?PROMPT:Text)
                    TEXT,AT(10,20,100,50),USE(?TEXT),BOXED,FLAT,VSCROLL
               END
               TAB('String'),USE(?TAB:String)
                    STRING('*** A String Example to Show for Fun'),AT(10,10), |
                              USE(?STRING)
                    STRING('Angle String'),AT(10,20,15,50),USE(?STRING:Angle),CENTER, |
                              ANGLE(900)
               END
          END
          BUTTON('&Back'),AT(1,127,60,20),USE(?BTN:Back),DEFAULT,IMM,LEFT
          BUTTON('&Next'),AT(62,127,60,20),USE(?BTN:Next),IMM,LEFT
          BUTTON('&OK'),AT(130,127,60,20),USE(?BTN:Ok),LEFT
          BUTTON('&Cancel'),AT(191,127,60,20),USE(?BTN:Cancel),LEFT
     END
     
  CODE 
  AnyScreen:Init()
  AnyScreen:SetCSSFile('AnyTheme.css')  
  OPEN(TabWindow)
  ?SHEET{PROP:Wizard} = True 
  DO InitControlProperties
  DO InitList
  DO InitCombo
  ACCEPT
    CASE EVENT()
    OF EVENT:Selected
      DO SetSelected
    OF EVENT:Accepted
      CASE ACCEPTED()
      OF ?BTN:Ok OROF ?BTN:Cancel
        BREAK
      OF ?BTN:Next 
        IF CHOICE(?SHEET) < ?SHEET{PROP:NumTabs}
          SELECT(?SHEET{PROP:Child,CHOICE(?SHEET)+1})     
        END  
      OF ?BTN:Back
        IF CHOICE(?SHEET) > 1
          SELECT(?SHEET{PROP:Child,CHOICE(?SHEET)-1})     
        END  
      END  
    END  
    DO SetControlProperties
  END 
  FREE(CQ)
  FREE(LQ)
  CLOSE(TabWindow)
  AnyScreen:Kill()  
  RETURN

SetSelected ROUTINE
  Tab# = ?SHEET{PROP:ChoiceFEQ}
  Sel# = SELECTED()
  CASE Sel#{PROP:Type}
  OF CREATE:Text
    Type" = 'Text'
  OF CREATE:Entry
    Type" = 'Entry'
  OF CREATE:Spin
    Type" = 'Spin'
  OF CREATE:Combo
    Type" = 'Combo'
  OF CREATE:List  
    Type" = 'List'
  ELSE
    Type" = Sel#{PROP:Text}
  END  
        
SetControlProperties ROUTINE 
  ?BTN:Next{PROP:Disable} = CHOOSE(CHOICE(?SHEET)=?SHEET{PROP:NumTabs})
  ?BTN:Back{PROP:Disable} = CHOOSE(CHOICE(?SHEET)=1)
  0{PROP:Text} = 'Sel=' & Sel# & '/' & Type"
  
InitControlProperties ROUTINE
  ?BTN:Ok{PROP:Icon} = ICON:Ok
  ?BTN:Cancel{PROP:Icon} = ICON:Cancel
  ?BTN:Back{PROP:Icon} = 'BtnBack.ico'
  ?BTN:Next{PROP:Icon} = 'BtnNext.ico'
  CHANGE(?SPIN:Date,TODAY())
  

InitList ROUTINE
  LOOP 10 TIMES 
    Ndx# += 1
    LQ.Id = Ndx#
    LQ.Str = Ndx# & ' Record'
    LQ.Mark = False 
    LQ.ViewPosition = POSITION(LQ)
    ADD(LQ)
  END 
  ?LIST{PROP:LineHeight} = 10
  ?LIST{PROPLIST:BarFrame} = COLOR:Silver
  

InitCombo ROUTINE
  LOOP 6 TIMES 
    Ndx# += 1
    CQ.Id = Ndx#
    CQ.Str = Ndx# & ' Combo Record'
    ADD(CQ)
  END 
  ?COMBO{PROP:LineHeight} = 10
    